<id>
Chat Bubbles!
</id>

<version>
1.5 SP1
</version>

<mod info>
Updated in 1.5: Now far more compatable with other mods. You can choose which boards you want to display in chat bubbles by putting them in the list using the Chat Bubbles! link in YaBB Admin.

A few years ago I wrote my own bulletin board system called WebBBS that's still floating around the net and occasionally in use. It was well loved by the users but lacked some things I never got around to implementing:
  1. threading
  2. user accounts
  3. a nice maintenance system
YaBB has all these. When I switched to YaBB I wanted to get back the old feeling of the BBS I designed long ago. I modified YaBB 1 Gold - Release but never made a mod for it. So when I had to edit SP1 to support it, thanks to the requests of a few people I've added a mod.

huki1.gif through huki6.gif must be placed in your YaBBImages directory.

The bubbles can only appear in white. This cannot be edited. This is because the corner graphics are white. If you'd like the bubble to be another color, you'll need to edit this mod and replace all instances of bgcolor="#FFFFFF" with the color you'd like. Then change the color of the corner graphics to match.

For an example of how a forum looks when running this mod, view screenshot.gif.
</mod info>

<author>
D-BOY
</author>

<homepage>
http://jumpstation.org/jumpstation/
</homepage>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=setcensor">$txt{'135'}</a>
</search for>

<replace>
        - <a href="$cgi;action=setcensor">$txt{'135'}</a><br>
        - <a href="$cgi;action=chatbubbles">Chat Bubbles!</a>
</replace>

<edit file>
YaBB.pl
</edit file>

<search for>
	elsif ($action eq 'clean_log') { require "$sourcedir/Admin.pl"; &clean_log; }
</search for>

<replace>
	elsif ($action eq 'clean_log') { require "$sourcedir/Admin.pl"; &clean_log; }
	elsif ($action eq 'chatbubbles') { require "$sourcedir/AdminEdit.pl"; &ChatBubbles; }
	elsif ($action eq 'chatbubbles2') { require "$sourcedir/AdminEdit.pl"; &ChatBubbles2; }
</replace>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
sub SetCensor2 {
	&is_admin;
	$FORM{'censored'} =~ tr/\r//d;
	$FORM{'censored'} =~ s~\A[\s\n]+~~;
	$FORM{'censored'} =~ s~[\s\n]+\Z~~;
	$FORM{'censored'} =~ s~\n\s*\n~\n~g;
	my @lines = split( /\n/, $FORM{'censored'} );
	fopen(FILE, ">$vardir/censor.txt", 1);
	foreach my $i (@lines) {
		$i =~ tr/\n//d;
		unless( $i && $i =~ m~.+\=.+~ ) { next; }
		print FILE "$i\n";
	}
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}
</search for>

<replace>
sub SetCensor2 {
	&is_admin;
	$FORM{'censored'} =~ tr/\r//d;
	$FORM{'censored'} =~ s~\A[\s\n]+~~;
	$FORM{'censored'} =~ s~[\s\n]+\Z~~;
	$FORM{'censored'} =~ s~\n\s*\n~\n~g;
	my @lines = split( /\n/, $FORM{'censored'} );
	fopen(FILE, ">$vardir/censor.txt", 1);
	foreach my $i (@lines) {
		$i =~ tr/\n//d;
		unless( $i && $i =~ m~.+\=.+~ ) { next; }
		print FILE "$i\n";
	}
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

# Chat Bubbles 1.5
# These two functions allow for the addition and
# removal of forms to display as chat bubbles
sub ChatBubbles {
	&is_admin;
	my( @bubbles, $i );
	fopen(FILE, "$vardir/chatbubbles.txt");
	@bubbles = <FILE>;
	fclose(FILE);
	foreach $i (@bubbles) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	$yymain .= qq~
<table border="0" width="300" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/info.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>Boards to Display as Chat Bubbles</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size=2>
    <form action="$cgi;action=chatbubbles2" method="POST">
    Type one board name per line. The board names are that appear in your url as board=[namehere]. You can also view them in the edit boards function.<br>
    <textarea cols=55 rows=6 name="bubbles">
~;
	foreach $i (@bubbles) {
		$yymain .= "$i\n";
	}
	$yymain .= qq~
</textarea><br><BR>
    <input type=submit value="$txt{'10'}"></form></font></td>
  </tr>
</table>
~;
	$yytitle = "$txt{'135'}";
	&template;
	exit;
}

sub ChatBubbles2 {
	&is_admin;
	$FORM{'bubbles'} =~ tr/\r//d;
	$FORM{'bubbles'} =~ s~\A[\s\n]+~~;
	$FORM{'bubbles'} =~ s~[\s\n]+\Z~~;
	$FORM{'bubbles'} =~ s~\n\s*\n~\n~g;
	my @lines = split( /\n/, $FORM{'bubbles'} );
	fopen(FILE, ">$vardir/chatbubbles.txt", 1);
	foreach my $i (@lines) {
		$i =~ tr/\n//d;
		print FILE "$i\n";
	}
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}
# end changes by Chat Bubbles! 1.5
</replace>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		# Print the post and user info for the poster.
</search for>

<replace>
		# Print the post and user info for the poster.
	# Chat Bubbles! 1.5
	# This code determines if the current board is one
	# that needs to be displayed in chat bubbles.
	$dobubbles = '0';
	my( @bubbles, $i );
	fopen(FILE, "$vardir/chatbubbles.txt");
	@bubbles = <FILE>;
	fclose(FILE);
	foreach $i (@bubbles) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
		if ($i eq $currentboard) {
			$dobubbles = '1';
		}
	}
	# Chat Bubbles display code
if ($dobubbles eq '1') {		
	if ((($counter % 2) == '0')||($counter == '0')) {
		$yymain .= qq~
<a name="$counter">
      <table cellpadding=0 cellspacing=0 border=0 width="100%" bgcolor="$windowbg" class="windowbg" align="center">
  <tr><td>
      <table cellpadding=0 cellspacing=0 border=0 width="96%" bgcolor="$windowbg" class="windowbg" align="center">
  <tr> 
    <td valign="top"> 
      <table border="0" cellpadding="0" cellspacing="0">
        <tr>
          <td width="100%"><font size=1>$usernamelink</font></a> 
          </td>
        </tr>
        <tr>
          <td width="100%"><font size=1>
            <center>~;
	if($musername ne "Guest") {
		$yymain .= qq~
            $userprofile[13]
            $memberinfo<BR>
            $userprofile[12]
            $userprofile[8] $icqad &nbsp; $userprofile[10] $yimon &nbsp; $userprofile[9]<BR>
~;
	}
	if($musername eq "Guest") {
		$yymain .= qq~
            <BR><a href="mailto:$memail">$img{'email_sm'}</a><BR><BR>
~;
	}
	elsif ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $allow_hide_email ne 1) {
		$yymain .= qq~
            $profbutton$userprofile[4] <a href="mailto:$memail">$img{'email_sm'}</a>$sendm<BR><BR>
~;
	} else {
		$yymain .= qq~
    $profbutton$userprofile[4]$sendm<BR><BR>
~;
	}
	$yymain .= qq~
            $userprofile[11]
            $postinfo
            </font>
          </td>
        </tr>
      </table>
    </td>    
    <td width="100%" valign="top">   
      <table border="0" cellpadding="0" cellspacing="0" width="100%">   
        <tr>   
          <td></td>   
          <td><img border="0" src="$imagesdir/huki1.gif" width="14" height="14"></td>   
          <td bgcolor="#FFFFFF" width="100%"><font size="1" color="#FFFFFF">.</font></td>   
          <td><img border="0" src="$imagesdir/huki2.gif" width="14" height="14"></td>   
        </tr>   
        <tr>   
          <td valign="top"><img border="0" src="$imagesdir/huki5.gif" width="30" height="30"></td>  
          <td bgcolor="#FFFFFF"> </td>
          <td bgcolor="#FFFFFF" width="100%">
            <table border="0" cellpadding="0" cellspacing="0" width="100%">
              <tr>
                <td width="100%">            <table width='100%' border='0'> 
              <tr> 
                <td align="left" valign="middle"><img src="$imagesdir/$micon.gif"></td> 
                <td align="left" valign="middle"> 
                <font size="2"><B>$msub</b></font><BR>   
                <font size="1">&#171; <B>$counterwords $txt{'30'}:</B> $messdate &#187;</font></td>   
                <td align="right" valign="bottom" nowrap height="20">   
                <font size=-1> $menusep<a href="$cgi;action=post;num=$viewnum;quote=$counter;title=$txt{'116'};start=$start">$img{'replyquote'}</a>$menusep<a href="$cgi;action=modify;message=$counter;thread=$viewnum">$img{'modify'}</a>   
~;
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername) {
		$yymain .= qq~  $menusep<a href="$cgi;action=modify2;thread=$viewnum;id=$counter;d=1">$img{'delete'}</a></font>~;
	}

	$yymain .= qq~
                </td>   
              </tr>   
            </table> </td>  
              </tr>  
              <tr>  
                <td width="100%"> 
                  <hr size="1">
            	        <font size="2">$message</font>
                </td> 
              </tr> 
              <tr> 
                <td width="100%"><font size="1">$userprofile[5]</font>  
                </td> 
              </tr> 
            </table></td> 
          <td bgcolor="#FFFFFF"> </td> 
        </tr> 
        <tr> 
          <td></td> 
          <td><img border="0" src="$imagesdir/huki4.gif" width="14" height="14"></td> 
          <td bgcolor="#FFFFFF" width="100%"><font size="1" color="#FFFFFF">.</font></td> 
          <td><img border="0" src="$imagesdir/huki3.gif" width="14" height="14"></td> 
        </tr> 
      </table> 
      <table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr>
          <td width="50%"></td>
          <td width="50%" align="right">
           <font size="1"><img src="$imagesdir/ip.gif" alt="" border="0"> $mip</font>
          </td> 
        </tr> 
      </table>
          </td></tr></table> &nbsp;
    </td> 
  </tr> 
  </table>
~;
}

elsif (($counter % 2) != '0') {
		$yymain .= qq~
<a name="$counter">
      <table cellpadding=0 cellspacing=0 border=0 width="100%" bgcolor="$windowbg" class="windowbg" align="center">
  <tr><td>
      <table cellpadding=0 cellspacing=0 border=0 width="96%" bgcolor="$windowbg" class="windowbg" align="center">
  <tr> 
    <td width="100%" valign="top">   
      <table border="0" cellpadding="0" cellspacing="0" width="100%">   
        <tr>   
          <td><img border="0" src="$imagesdir/huki1.gif" width="14" height="14"></td>   
          <td bgcolor="#FFFFFF" width="100%"><font size="1" color="#FFFFFF">.</font></td>   
          <td><img border="0" src="$imagesdir/huki2.gif" width="14" height="14"></td>   
          <td></td>   
        </tr>   
        <tr>   
          <td bgcolor="#FFFFFF"> </td>
          <td bgcolor="#FFFFFF" width="100%">
            <table border="0" cellpadding="0" cellspacing="0" width="100%">
              <tr>
                <td width="100%">            <table width='100%' border='0'> 
              <tr> 
                <td align="left" valign="middle"><img src="$imagesdir/$micon.gif"></td> 
                <td align="left" valign="middle"> 
                <font size="2"><B>$msub</b></font><BR>   
                <font size="1">&#171; <B>$counterwords $txt{'30'}:</B> $messdate &#187;</font></td>   
                <td align="right" valign="bottom" nowrap height="20">   
                <font size=-1> $menusep<a href="$cgi;action=post;num=$viewnum;quote=$counter;title=$txt{'116'};start=$start">$img{'replyquote'}</a>$menusep<a href="$cgi;action=modify;message=$counter;thread=$viewnum">$img{'modify'}</a>   
~;
		if(exists $moderators{$username} || $settings[7] eq 'Administrator') {
$yymain .= qq~
                $menusep<a href="$cgi;action=modify2;thread=$viewnum;id=$counter;d=1">$img{'delete'}</a></font>
~;
}
$yymain .= qq~
                </td>   
              </tr>   
            </table> </td>  
              </tr>  
              <tr>  
                <td width="100%"> 
                  <hr size="1">
            	        <font size="2">$message</font>
                </td> 
              </tr> 
              <tr> 
                <td width="100%"><font size="1">$userprofile[5]</font>  
                </td> 
              </tr> 
            </table></td> 
          <td bgcolor="#FFFFFF"> </td> 
          <td valign="top"><img border="0" src="$imagesdir/huki6.gif" width="30" height="30"></td>  
        </tr> 
        <tr> 
          <td><img border="0" src="$imagesdir/huki4.gif" width="14" height="14"></td> 
          <td bgcolor="#FFFFFF" width="100%"><font size="1" color="#FFFFFF">.</font></td> 
          <td><img border="0" src="$imagesdir/huki3.gif" width="14" height="14"></td> 
          <td></td> 
        </tr> 
      </table> 
      <table border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr>
          <td width="50%" align="left"><font size="1"><img src="$imagesdir/ip.gif" alt="" border="0"> $mip</font></td>
          <td width="50%"></td> 
        </tr> 
      </table> 
          </td>
              <td valign="top"> 
      <table border="0" cellpadding="0" cellspacing="0">
        <tr>
          <td width="100%"><font size=1>$usernamelink</font></a> 
            </font></td>
        </tr>
        <tr>
          <td width="100%"><font size=1>
            <center>~;
	if($musername ne "Guest") {
		$yymain .= qq~
            $userprofile[13]
            $memberinfo<BR>
            $userprofile[12]
            $userprofile[8] $icqad &nbsp; $userprofile[10] $yimon &nbsp; $userprofile[9]<BR>
~;
	}
	if($musername eq "Guest") {
		$yymain .= qq~
            <BR><a href="mailto:$memail">$img{'email_sm'}</a><BR><BR>
~;
	}
	elsif ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $allow_hide_email ne 1) {
		$yymain .= qq~
            $profbutton$userprofile[4] <a href="mailto:$memail">$img{'email_sm'}</a>$sendm<BR><BR>
~;
	} else {
		$yymain .= qq~
    $profbutton$userprofile[4]$sendm<BR><BR>
~;
	}
	$yymain .= qq~
            $userprofile[11]
            $postinfo
            </font>
          </td>
        </tr>
      </table>   <br>
    </td>    </tr></table> &nbsp;
    </td> 
  </tr> 
  </table>
~;
}
}
	# If it's not to be displayed as chat bubbles,
	# then use the normal, default display
	else {
</replace>

<search for>
		$counter++;
</search for>

<replace>
	}
	# end changes by Chat Bubbles! 1.5
		$counter++;
</replace>